<?php
// Popularity Checker
// How many Del.icio.us bookmarks for a website?
// (c) 2008 Scriptol.com
// Free under the GNU GPL 2 License.
// Requires the PHP interpreter.
// Sources are compiled with the Scriptol PHP compiler 7.0
// www.scriptol.com
//
// The program checks for the number of bookmarks
// to each page of a website from the "http://del.icio.us site".
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
//
include_once("path.php");
include_once("dom.php");
include_once("url.php");
$QUIET=false;
$RECURSE=false;
$PROCESSDEFAULT=true;
$LEVEL=0;
$counter=0;
$okcount=0;
$params=array();
$checked=array();
$marked=array();
$broken=array();
function usage()
{
   echo "\n";
   echo "Popularity Checher 1.2 - (c) 2008 Scriptol.com - Freeware.", "\n";
   echo "----------------------------------------------------------", "\n";
   echo "Syntax:", "\n";
   echo "  solp popche [options] url", "\n";
   echo "Options:", "\n";
   echo "  -r follow links (default the page only).", "\n";
   echo "  -v verbose, display more infos.", "\n";
   echo "  -q quiet, display nothing.", "\n";
   echo "Arguments:", "\n";
   echo "  url: http address of a page, usually the home page.", "\n";
   echo "Results stored into bookmarks.log.", "\n";
   echo "More info at: http://www.scriptol.com/scripts/", "\n";
   exit(0);
   return;
}

function splitSite($url)
{
   $pos=strpos($url,'/',8);
   if($pos===false)
   {
      $ext=Path::getExtension($url);
      global $extensions;
      if(!in_array($ext,$extensions))
      {
         return array($url,"");
      }
      die("$url not a valid url");
   }
   $site=substr($url,0,$pos);
   $filename=substr($url,$pos+1);
   return array($site,$filename);
}

function isInternal($url)
{
   global $website;
   $l=strlen($website);
   $url=strtolower($url);

   if($website===substr($url,0,$l))
   {
      return true;
   }
   return false;
}

function makeLogs($flag)
{
   global $okcount;   
   global $counter;   
   $f=fopen("bookmarks.log","w");
   fwrite($f,"[Bookmarked]\n");
   global $marked;
   if(count($marked)===0)
   {
      fwrite($f,"None\n");
   }
   else
   {
      reset($marked);
      do
      {
         $k= key($marked);
         $v= current($marked);
         $line=$v." ".$k;
         fwrite($f,$line);
         fwrite($f,"\n");
      }
      while(!(next($marked) === false));

      global $okcount;
      $p=($okcount>1?"s":"");
      fwrite($f,"$okcount bookmark$p, for $counter pages checked.\n");
      if($flag)
      {
         fwrite($f,"Not completed, access denied.");
      }
   }
   fwrite($f,"\n");
   fwrite($f,"[Broken]\n");
   global $broken;
   if(count($broken)===0)
   {
      fwrite($f,"None\n");
   }
   else
   {
      reset($broken);
      do
      {
         $b= current($broken);
         fwrite($f,$b);
         fwrite($f,"\n");
      }
      while(!(next($broken) === false));

   }
   fclose($f);
   return;
}

function ping($url)
{
   $bookPage=@file_get_contents("http://del.icio.us/url/check?url=$url&submit=check%20url&settagview=list");
   if(trim($bookPage)==="")
   {
      echo "Access denied at $url", "\n";
      return -1;
   }
   $result=array();
   $exp="";
   
    $exp = '/<span class="savers\d+">(\d+)<\/span>/';
    
   $x=intVal(preg_match($exp,$bookPage,$result));
   if($x===0)
   {
      return 0;
   }
   return intval($result[1]);
}

function checkMarks($url)
{
   global $counter;
   $counter+=1;
   global $checked;
   array_push($checked,$url);
   global $DEBUG;
   if($DEBUG)
   {
      echo "Checking $url", "\n";
   }
   $result=ping($url);
   if($result>0)
   {
      global $okcount;
      $okcount+=$result;
      echo $result, " ", "in", " ", $url, "\n";
      global $marked;
      $marked[$url]=$result;
   }
   if($result<0)
   {
      $e="Access to results denied.";
      global $broken;
      array_push($broken,$e);
      makeLogs(true);
      die($e);
   }
   return $result;
}

function pageScan($fname,$caller)
{
   $current=null;
   $elem=null;
   $xres=0;
   $links=array();
   $d=new DOMDocument();

   
    $xres = @$d->loadHTMLFile($fname);
  
   if($xres===false)
   {
      echo "Error $fname not found in $caller", "\n";
      global $broken;
      array_push($broken,$fname);
      return array();
   }
   $dnl=$d->getElementsByTagName("a");
   if($dnl->length===0)
   {
      return array();
   }
   for($i=0;$i<=$dnl->length;$i++)
   {
      $current=$dnl->item($i);
      if($current===null)
      {
         continue;
      }
      $elem=$current;
      if($elem->hasAttribute("href"))
      {
         array_push($links,$elem->getAttribute("href"));
      }
   }
   return $links;
}

function httpCheck($page,$caller)
{
   $links=array();
   $reldir="";
   $src="";
   $ext="";
   if($page{0}===".")
   {
      return;
   }
   global $DEBUG;
   if($DEBUG)
   {
      echo "Entering $page ", "\n";
   }
   if(substr($page,-1,1)!="/")
   {
      $infos=pathinfo($page);
      $reldir=@strtolower($infos{'dirname'});
      $src=@strtolower($infos{'filename'});
      $ext=@strtolower($infos{'extension'});

      if($ext!=false)
      {
         $ext=".".$ext;
         global $extensions;
         if(!in_array($ext,$extensions))
         {
            return;
         }
         $src.=$ext;
      }
      $status=sockAccess($page);
      
      if($status===301)
      {
         global $VERBOSE;
         if($VERBOSE)
         {
            echo "Skip $page redirected.", "\n";
         }
         global $broken;
         array_push($broken,$page);
         return;
      }
      else
      {
         if($status===404)
         {
            echo "Broken link $page", "\n";
            return;
         }
      else
      {
         if($status===200)
         {
         }
      else
      {
         echo "Unknow status code $status", "\n";
         return;
      }
      }}
   }
   else
   {
      $oldir=$page;
      $page=findDefault($page);
      global $VERBOSE;
      if($VERBOSE)
      {
         if($oldir!=$page)
         {
            echo "Default page $page", "\n";
         }
      }
      global $checked;
      array_push($checked,$oldir);
   }
   global $VERBOSE;
   if($VERBOSE)
   {
      echo "Processing  $reldir/$src", "\n";
   }
   global $checked;
   if(!in_array($page,$checked))
   {
      checkMarks($page);
   }
   global $RECURSE;
   if(!$RECURSE)
   {
      return;
   }
   global $LEVEL;
   if($LEVEL<1)
   {
      return;
   }
   $LEVEL-=1;

   $links=pageScan($page,$caller);

   if(count($links)===0)
   {
      return;
   }
   $l=count($links);
   for($i=0;$i<$l;$i++)
   {
      $link=$links[$i];
      if($link{0}==="#")
      {
         continue;
      }
      $p=strpos($link,"#",0);
      if($p!=0)
      {
         $link=substr($link,0,$p);
      }
      if(hasProtocol($link))
      {
         if(!isInternal($link))
         {
            continue;
         }
      }
      else
      {
         if(strlen($link)>7)
         {
            if(substr($link,0,7)==="mailto:")
            {
               if($DEBUG)
               {
                  echo "Skipped mailto.", "\n";
               }
               continue;
            }
         }
         $link=Path::merge($reldir,$link);
      }
      global $PROCESSDEFAULT;
      if($PROCESSDEFAULT)
      {
         if(substr($link,-1)==="/")
         {
            $home=findDefault($link);
            if(!in_array($home,$checked))
            {
               array_push($checked,$home);
            }
         }
      }
      if(in_array($link,$checked))
      {
         continue;
      }
      httpCheck($link,$page);
   }
   return;
}

function processCommand($argnum,$arguments)
{
   $opt="";
   if($argnum<2)
   {
      usage();
   }
   reset($arguments);
   do
   {
      $param= current($arguments);
      if(strlen($param)>1)
      {
         $opt=substr($param,0,2);
      }
      else
      {
         usage();
      }
      
      if($opt==="-v")
      {
         global $VERBOSE;
         $VERBOSE=true;
         continue;
      }
      else
      {
         if($opt==="-q")
         {
            global $QUIET;
            $QUIET=true;
            continue;
         }
      else
      {
         if($opt==="-u")
         {
            global $DEBUG;
            $DEBUG=true;
            continue;
         }
      else
      {
         if($opt==="-r")
         {
            global $RECURSE;
            $RECURSE=true;
            global $LEVEL;
            $LEVEL=1;

            continue;
         }
      }}}
      if(substr($param,0,5)==="http:")
      {
         global $server;
         $server=$param;
         continue;
      }
      if($param{0}==="-")
      {
         echo "Unknown command $param", "\n";
         usage();
      }
      global $server;
      if($server ==false)
      {
         $server=$param;
         continue;
      }
      echo "Unknown command $param", "\n";
      usage();
   }
   while(!(next($arguments) === false));

   global $server;
   if($server ==false)
   {
      die("You must provide a URL.");
   }
   global $params;
   $params["server"]=$server;

   return;
}

function main($argc,$argv)
{
   $filename="";
   $x=array_slice($argv,1);
   processCommand($argc,$x);
   global $server;
   global $params;
   $server=$params["server"];

   if(!hasProtocol($server))
   {
      $server="http://".$server;
   }
   global $website;
   $_I1=splitSite($server);
   $website=reset($_I1);
   $filename=next($_I1);
   $website=strtolower($website);

   global $domain;
   $domain=substr($website,7);
   if(substr($domain,-1,1)==="/")
   {
      $domain=substr($domain,0);
   }
   global $QUIET;
   if(!$QUIET)
   {
      global $VERBOSE;
      if($VERBOSE===true)
      {
         echo "Verbose mode enabled", "\n";
      }
      global $DEBUG;
      if($DEBUG===true)
      {
         echo "Debug mode enabled", "\n";
      }
      echo "Website is", " ", $website, "\n";
      echo "Domain is", " ", $domain, "\n";
      global $LEVEL;
      if($LEVEL)
      {
         echo "Internal links in the page checked too", "\n";
      }
      echo "Starting from $server", "\n";
   }
   httpCheck($server,$server);
   if($QUIET)
   {
      return 0;
   }
   global $okcount;
   global $counter;
   echo $okcount, " ", "Bookmark".($okcount>1?"s":""), " ", "out of", " ", $counter, " ", "pages checked.", "\n";
   makeLogs(false);
   return 0;
}

main(intVal($argc),$argv);

?>
